#ifndef COMMON_CK
#define COMMON_CK

#include "DispMsg.h"

using namespace SimuLambda;

	extern int u;	
	extern int g;	
	extern int N;	

	extern int p;	
	extern int q;	
	extern int r;	

	extern double * chi2;
	extern double * Lambda;

	extern double StatLambda;

	extern int ndata;

	extern int winW, winH;

	void qSort( double * d, int Lb, int Ub );


	using namespace System;

	class CalcBinPIntvl {

		double p, pa;

		int N, k;

		double * LogCombi;



		//     Bisection@ɂ鍪̌vZ    

		void Bisection(
			double s,					 //   f֐̂Ƃ s > 0.0
			double c,					 //   ɑ΂֐l
			double L_b, double U_b,		 //   ̑݋Ԃ̉Ə
			double & Root,				 //     f(Root) = c
			double acc){
			if ((Cum_prob(L_b) - c) * (Cum_prob(U_b) - c) > 0.0){
				throw  gcnew Exception("Ɖ̑gݍ킹sK؂łB");
			}
			do {
				double m = 0.5 * (L_b + U_b);
				double v = Cum_prob(m);
				if (s * (v - c) > 0.0) {
					U_b = m;
				}
				else {
					L_b = m;
				}
			} while ((Math::Abs(U_b - L_b) >= acc * Math::Abs(U_b))
				&&
				((Math::Abs(U_b) + Math::Abs(L_b)) >= 1.0e-7)
				);
			Root = 0.5 * (L_b + U_b);
		}

		void BisectionU(
			double s,					 //   f֐̂Ƃ s > 0.0
			double c,					 //   ɑ΂֐l
			double L_b, double U_b,		 //   ̑݋Ԃ̉Ə
			double & Root,				 //     f(Root) = c
			double acc){
			if ((UCum_prob(L_b) - c) * (UCum_prob(U_b) - c) > 0.0){
				throw  gcnew Exception("Ɖ̑gݍ킹sK؂łB");
			}
			do {
				double m = 0.5 * (L_b + U_b);
				double v = UCum_prob(m);
				if (s * (v - c) > 0.0) {
					U_b = m;
				}
				else {
					L_b = m;
				}
			} while ((Math::Abs(U_b - L_b) >= acc * Math::Abs(U_b))
				&&
				((Math::Abs(U_b) + Math::Abs(L_b)) >= 1.0e-7)
				);
			Root = 0.5 * (L_b + U_b);
		}


		double prob_term(double p, int N, int i){
			if (p <= 0.0){
				if (i >= 1) return 0.0;
				else		return 1.0;
			}
			else if (p >= 1.0){
				if (i == N) return 1.0;
				else		return 0.0;
			}
			else{
				return Math::Exp(LogCombi[i] + (i * Math::Log(p) + (N - i) * Math::Log(1.0 - p)));
			}
		}

		double Cum_prob(double p){
			double v = 0.0;
			for (int i = 0; i <= k; i++)
				v += prob_term(p, N, i);
			return v;
		}


		double UCum_prob(double p){
			double v = 0.0;
			for (int i = N; i >= k; i--)
				v += prob_term(p, N, i);
			return v;
		}

	public:
		void calc95Intvl(int vN, int vk, double & LB, double & UB){
			DispMsg dm;
			dm.Show();
			dm.SetDesktopLocation((winW - dm.Width) / 2, (winH - dm.Height) / 2);
			dm.InitMe();

			pa = 0.05;		//	 (100.0 - p) / 100.0;
			N = vN;		//	 int::Parse(textBoxN->Text);
			k = vk;		//	 int::Parse(textBoxK->Text);

			LogCombi = new double[N + 1];
			for (int i = 0; i <= N; i++){
				if ((i == 0) || (i == N)) LogCombi[i] = 0.0;
				else {
					double v = 0.0;
					for (int j = i; j >= 1; j--)
						v += Math::Log(N + 1.0 - j) - Math::Log(j);
					LogCombi[i] = v;
				}
			}

			if (UCum_prob(0.0) > (pa / 2.0)){
				LB = 0.0;
				Bisection( -1.0, pa / 2.0, 0.0, 1.0, UB, 1.0e-7);
			}
			else{
				if (Cum_prob(1.0) > (pa / 2.0)){
					UB = 1.0;
					BisectionU( 1.0, pa / 2.0, 0.0, 1.0, LB, 1.0e-7);
				}
				else{
					Bisection( -1.0, pa / 2.0, 0.0, 1.0, UB, 1.0e-7);
					BisectionU( 1.0, pa / 2.0, 0.0, 1.0, LB, 1.0e-7);
				}
			}

			delete[] LogCombi;

			dm.Close();
		}

	};

#endif